#!/bin/bash  

SYS="/etc/sysconfig/envole"

. ParseDico
. /usr/share/eole/FonctionsEoleNg

# compatibilite
NOM_ETAB=`EscapeSQL "$libelle_etab"`
NOM_DOMAINE=$domaine_messagerie_etab
wordpressmu=$scribe_envole_wordpressmu
RNE_ETAB=$numero_etab
#RNE_ETAB2=$numero_etab

## creation des bases et des users ##
PASS_ROOT=`/usr/bin/pwgen -1sn 8`;
echo "UPDATE user SET password=PASSWORD('$PASS_ROOT') WHERE user='root';
flush  privileges;" | mysql --defaults-file=/etc/mysql/debian.cnf mysql

if [ ! -d /var/lib/mysql/wordpressmu ]
then

PASS_WORDPRESSMU=`/usr/bin/pwgen -1sn 12`
echo "DROP DATABASE IF EXISTS wordpressmu;
CREATE DATABASE wordpressmu;
USE wordpressmu;GRANT ALL PRIVILEGES ON wordpressmu.* TO 'wordpressmu'@'localhost'
IDENTIFIED BY '$PASS_WORDPRESSMU' WITH GRANT OPTION;flush  privileges;" | mysql -u root --password=$PASS_ROOT > /dev/null


sed -e "s@DNS_ETAB@"$NOM_DOMAINE"@" $SYS/scribe_wordpressmu.sql  > $SYS/scribe_wordpressmu.sql.1
sed -e "s@DNS_ETAB@"$NOM_DOMAINE"@" $SYS/scribe_wordpressmu.sql.1  > $SYS/scribe_wordpressmu.sql.2
sed 's@'"NOM_ETAB"'@'"$NOM_ETAB"'@' $SYS/scribe_wordpressmu.sql.2  > $SYS/scribe_wordpressmu.sql.3
sed -e "s@RNE_ETAB@"$RNE_ETAB"@" $SYS/scribe_wordpressmu.sql.3  > $SYS/scribe_wordpressmu.sql.4
sed -e "s@RNE_ETAB2@"$RNE_ETAB"@" $SYS/scribe_wordpressmu.sql.4  > $SYS/scribe_wordpressmu.sql.5


mysql wordpressmu -u root -p$PASS_ROOT < $SYS/scribe_wordpressmu.sql.5

rm $SYS/scribe_wordpressmu.sql.1
rm $SYS/scribe_wordpressmu.sql.2
rm $SYS/scribe_wordpressmu.sql.3
rm $SYS/scribe_wordpressmu.sql.4
rm $SYS/scribe_wordpressmu.sql.5

else

PASS_WORDPRESSMU="toto"

fi

sed -e "s@PASS_WORDPRESSMU@"$PASS_WORDPRESSMU"@" $SYS/wp-configmu.php.ori  > /var/www/html/wordpressmu/wp-config.php


# pour le local_apps et grr.ini
cp $SYS/wordpressmu.ini /usr/share/sso/app_filters/
sed -e "s@NOM_DOMAINE@"$NOM_DOMAINE"@" $SYS/local_apps_wordpressmu.ini  > $SYS/local_apps_wordpressmu.ini.1

cat $SYS/local_apps_wordpressmu.ini.1 >> /usr/share/sso/app_filters/local_apps.ini
rm $SYS/local_apps_wordpressmu.ini.1

PASS_ENVOLE=$(echo `grep dbPass /var/www/html/envole/serverdata.php` | cut -d"=" -f2|cut -d'"' -f2)

mysql portal -u envole -p$PASS_ENVOLE < $SYS/scribe_wordpressmu_envole.sql

sed -e "s@DNS_ETAB@"$NOM_DOMAINE"@" $SYS/wpcas-conf.mu.php.ori  > /var/www/html/wordpressmu/wp-content/mu-plugins/wpcas-conf.php




# insertion du champ de mise a jour dans la bdd cel_conf
PASS_CEL_CONF=$(echo `grep db_pass_cel_conf /var/www/html/envole/connect_cel_conf.php` | cut -d"=" -f2|cut -d'"' -f2)
echo "use cel_conf; INSERT INTO cel_param ( id , param , affichage , value, writable , visible , categorie )VALUES (NULL , 'version_wordpressmu', 'Numero de sous-version WordpressMu EnvOLE', '0', '0', '0', 'Etablissement'); " | mysql -u cel_conf --password=$PASS_CEL_CONF > /dev/null



# pour le profil
#cp $SYS/sso/user_infos/* /usr/share/sso/user_infos/

chown -R www-data:www-data /var/www/html/wordpress/*

#/etc/init.d/apache2 restart
/etc/init.d/eole-sso restart
