#!/bin/bash


# A mettre a jour pour un nouveau script
NUM_MAJ=1
MODULE=wordpressmu
#placer ici les modifications de fichiers


#placer ici les modifications de bases de donnees
# si la mise à jour comporte une modification de la base de données

if [ -e $SYS/maj_envole_${MODULE}_${NUM_MAJ}.sql ]
then

cd /root/
## Sauvegarde des bases de donnees en fichiers .sql

PASS_WORDPRESSMU=$(echo `grep DB_PASSWORD /var/www/html/wordpressmu/wp-config.php` | cut -d"'" -f4|cut -d'"' -f2)
mysqldump -u$MODULE -p$PASS_WORDPRESSMU $MODULE > ${MODULE}_`date +%D | sed 's;/;-;g'`.sql
## Compression des exports en tar.bz2 
tar jcf ${MODULE}_maj_env_${NUM_MAJ}_`date +%D | sed 's;/;-;g'`.sql.tar.bz2 ${MODULE}_`date +%D | sed 's;/;-;g'`.sql
## Suppression des exports non compresses
rm ${MODULE}_`date +%D | sed 's;/;-;g'`.sql

mysql $MODULE -u $MODULE -p$PASS_WORDPRESSMU < $SYS/maj_envole_${MODULE}_$NUM_MAJ.sql

fi

chmod 755 /var/www/html/wordpressmu /var/www/html/wordpressmu/wp-content/ 
/etc/init.d/eole-sso restart

# A toujours laisser en fin de script de mise a jour, permet la mise a jour de la base de donnees cel_conf et assure que la mise a jour ne sera pas executee deux fois

PASS_CEL_CONF=$(echo `grep db_pass_cel_conf /var/www/html/envole/connect_cel_conf.php` | cut -d"=" -f2|cut -d'"' -f2)

echo "use cel_conf;  UPDATE cel_param SET value='$NUM_MAJ' WHERE param='version_${MODULE}' ; " | mysql -u cel_conf --password=$PASS_CEL_CONF > /dev/null
echo "Fin de la mise a jour $MODULE " $NUM_MAJ 
